//	(c) 2000 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.
#if !defined(AFX_ARRANGEGRAPHDIALOG_H__D8D42310_FE8E_11D3_A36C_00C04F72D141__INCLUDED_)
#define AFX_ARRANGEGRAPHDIALOG_H__D8D42310_FE8E_11D3_A36C_00C04F72D141__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ArrangeGraphDialog.h : header file
//

#include "validate.h"

/////////////////////////////////////////////////////////////////////////////
// CArrangeGraphDialog dialog

class CArrangeGraphDialog : public CDialog, public validate
{
// Construction
public:
	CArrangeGraphDialog(float width, float height,
		float startX, float startY,
		float vertical, float horizontal, int rows, int cols,
		CWnd* pParent = NULL);

	BOOL GetData(float &width, float &height,
		float &startX, float &startY,
		float &vertical, float &horizontal, int &rows, int &cols);
	
	BOOL OnInitDialog();
	void UpdateLayout();

	int initRow, initCol;
	float hGap, vGap;

	CString hGap_string, vGap_string;

	// Should we apply the results to all graphs, or just the selected
	// graph?
	int apply_to_all;

	// Dialog Data
	//{{AFX_DATA(CArrangeGraphDialog)
	enum { IDD = IDD_ARRANGE_GRAPHS };
	CSpinButtonCtrl	m_row_spin;
	CSpinButtonCtrl	m_col_spin;
	CEdit	m_horizontal;
	CEdit	m_vertical;
	CString	m_height;
	CString	m_start_x;
	CString	m_start_y;
	CString	m_width;
	CString	m_row_edit;
	CString	m_col_edit;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CArrangeGraphDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CArrangeGraphDialog)
	virtual void OnOK();
	afx_msg void OnAllRadio();
	afx_msg void OnSelectedRadio();
	afx_msg void OnChangeRowEdit();
	afx_msg void OnChangeColEdit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ARRANGEGRAPHDIALOG_H__D8D42310_FE8E_11D3_A36C_00C04F72D141__INCLUDED_)
