//	(c) 2000 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.
//
// Extend the CCommandLineInfo class to provide support
// for addition command line flags and parameters
#ifndef __SGRAPH_COMMAND_LINE
#define __SGRAPH_COMMAND_LINE

#include <afxwin.h>
#include "list.h"
#include "Sgraph.h"

class CSGraphCommandLine : public CCommandLineInfo {
public:
	
	CSGraphCommandLine()
	{
		m_importXY = FALSE;
		m_importNXY = FALSE;
		m_importXYDX = FALSE;
		m_importXYDY = FALSE;
		m_importXYDXDY = FALSE;
		m_importWAV = FALSE;
		m_logX = FALSE;
		m_logY = FALSE;
		m_displayCommandLine = FALSE;
		m_pipe = FALSE;
	};

	// Has the user requested an ASCII or audio file import?
	BOOL m_importXY, m_importNXY, m_importXYDX, m_importXYDY,
		m_importXYDXDY, m_importWAV, m_displayCommandLine, m_logX, m_logY, m_pipe;

	// Has the user selected file(s) to be imported?
	BOOL ImportFile()
	{
		return m_importXY || m_importNXY || m_importXYDX || m_importXYDY ||
			m_importXYDXDY || m_importWAV;
	};

	// Return the type of file to be imported
	int GetImportFileOption()
	{
		if(m_importXY)
			return SGraph::SINGLE_PLOT;

		if(m_importNXY)
			return SGraph::MULTI_PLOT;

		if(m_importXYDX)
			return SGraph::SINGLE_PLOT_DX;

		if(m_importXYDY)
			return SGraph::SINGLE_PLOT_DY;

		if(m_importXYDXDY)
			return SGraph::SINGLE_PLOT_DX_DY;

		if(m_importWAV)
			return SGraph::AUDIO_WAVE;

		// Shouldn't get here!
		return -1;
	};

	// The address of a pipe handle
	CString m_pipe_addr;

	// A list of files to import from the command line (wildcards are expanded
	// into a list of strings).
	list<CString> m_import_filename;

	void ParseParam( LPCTSTR lpszParam, BOOL bFlag, BOOL bLast );
};

#endif