//	(c) 2000 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.

#if !defined(AFX_DERIVATIVEDIALOG_H__2A172E60_5E5D_11D4_A37A_00C04F72D141__INCLUDED_)
#define AFX_DERIVATIVEDIALOG_H__2A172E60_5E5D_11D4_A37A_00C04F72D141__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DerivativeDialog.h : header file
//

#include "PlotList.h"

/////////////////////////////////////////////////////////////////////////////
// CDerivativeDialog dialog

class CDerivativeDialog : public PlotListBox, public CDialog
{
// Construction
public:
	CDerivativeDialog(CDocument* pDoc, CWnd* pParent = NULL);
	
	BOOL OnInitDialog();

	SPlot& Derivative(SPlot &deriv, SPlot &plot, int id);

	CDocument* m_pDoc;
	
	// The radio buttons have the following resource defines:
	// IDC_RADIO_CENTER		1046
	// IDC_RADIO_LEFT		1047
	// IDC_RADIO_RIGHT		1048
	int deriv_loc; // == IDC_RADIO_CENTER, IDC_RADIO_LEFT or IDC_RADIO_RIGHT

	enum {THREE_PT_DERIV = 0, FIVE_PT_DERIV};

	// The number of points that will be used to compute the discrete
	// derivative.
	int deriv_num_point;

// Dialog Data
	//{{AFX_DATA(CDerivativeDialog)
	enum { IDD = IDD_DIFFERENTIATE };
	CComboBox	m_num_point;
	CComboBox	m_graph;
	CListBox	m_list;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDerivativeDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDerivativeDialog)
	virtual void OnOK();
	afx_msg void OnSelectChange();
	afx_msg void OnRadioCenter();
	afx_msg void OnRadioLeft();
	afx_msg void OnRadioRight();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DERIVATIVEDIALOG_H__2A172E60_5E5D_11D4_A37A_00C04F72D141__INCLUDED_)
