//	(c) 2000-2002 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.

#include "stdafx.h"
#include "sgraph.h"
#include "OverlapGraphDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COverlapGraphDialog dialog


COverlapGraphDialog::COverlapGraphDialog(int m_numGraph, CWnd* pParent /*=NULL*/)
	: CDialog(COverlapGraphDialog::IDD, pParent)
{
	if(m_numGraph <= 1){
		throw Error("Can't overlap less than two graphs!", 
			__FILE__, __LINE__);
	}

	numGraph = m_numGraph;

	//{{AFX_DATA_INIT(COverlapGraphDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void COverlapGraphDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COverlapGraphDialog)
	DDX_Control(pDX, IDC_TOP_GRAPH_COMBO, m_top_graph);
	DDX_Control(pDX, IDC_BOTTOM_GRAPH_COMBO, m_bottom_graph);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COverlapGraphDialog, CDialog)
	//{{AFX_MSG_MAP(COverlapGraphDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COverlapGraphDialog message handlers
BOOL COverlapGraphDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	CString counter;

	for(int i = 0;i < numGraph;i++){
		counter.Format("%d", i);
		m_top_graph.AddString(counter);
		m_bottom_graph.AddString(counter);
	}

	// By default, place graph 0 on top of graph 1
	m_top_graph.SetCurSel(0);
	m_bottom_graph.SetCurSel(1);

	return TRUE;
}

void COverlapGraphDialog::OnOK() 
{	
	topGraph = m_top_graph.GetCurSel();
	bottomGraph = m_bottom_graph.GetCurSel();

	if(topGraph == bottomGraph){
		AfxMessageBox("Unable to place a graph on top of itself!");

		// Reset the combo boxes
		m_top_graph.SetCurSel(0);
		m_bottom_graph.SetCurSel(1);

		return;
	}

	CDialog::OnOK();
}
