//	(c) 2000 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.

// PipeDialog.cpp : implementation file
//

#include "stdafx.h"
#include "sgraph.h"
#include "PipeDialog.h"
#include "sgraphDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPipeDialog dialog

// Local functions 
UINT PipeWrapper(LPVOID ptr);

CPipeDialog::CPipeDialog(LPVOID ptr, int pipeHandle)
	: CDialog(CPipeDialog::IDD, NULL)
{
	m_status = TRUE;
	m_ptr = ptr;
	m_pipeHandle = pipeHandle;

	//{{AFX_DATA_INIT(CPipeDialog)
	//}}AFX_DATA_INIT
}

BOOL CPipeDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Start the thread that will read the trajectory data
	AfxBeginThread(PipeWrapper, this);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CPipeDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPipeDialog)
	DDX_Control(pDX, IDC_READ_STATUS_TEXT, m_text);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPipeDialog, CDialog)
	//{{AFX_MSG_MAP(CPipeDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPipeDialog message handlers

void CPipeDialog::Message(CString &text)
{
	m_text.SetWindowText(text);
}

void CPipeDialog::Message(const char* text)
{
	m_text.SetWindowText(text);
}

void CPipeDialog::OnCancel() 
{	
	m_status = FALSE;

	// Don't call CDialog::OnCancel()! By setting status
	// to false, we will cause the reading thread to exit and
	// thereby close the window.
}

UINT PipeWrapper(LPVOID ptr)
{
	CPipeDialog *dlgPtr = (CPipeDialog*)(ptr);

	((CSgraphDoc*)(dlgPtr->m_ptr))->ListenToPipe(dlgPtr);

	// Close the window when we are done
	dlgPtr->Quit();

	return 0;
}
