//	(c) 2000 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.
#if !defined(AFX_PLOTOPTIONSDIALOG_H__F29B6051_F432_11D3_A367_00C04F72D141__INCLUDED_)
#define AFX_PLOTOPTIONSDIALOG_H__F29B6051_F432_11D3_A367_00C04F72D141__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// PlotOptionsDialog.h : header file
//
#include "PlotList.h"

/////////////////////////////////////////////////////////////////////////////
// CPlotOptionsDialog dialog

class CPlotOptionsDialog : public PlotListBox, public CDialog
{
// Construction
public:
	CPlotOptionsDialog(CDocument* pDoc, CWnd* pParent = NULL);
	
	BOOL OnInitDialog();

	void SetDefaultOptions();

	CDocument* m_pDoc;

	// These custom colors will be converted to 
	// COLORREF structures.
	int custom_symbol_color;
	int custom_line_color;

// Dialog Data
	//{{AFX_DATA(CPlotOptionsDialog)
	enum { IDD = IDD_PLOT_OPTIONS };
	CComboBox	m_symbol_type;
	CComboBox	m_symbol_size;
	CComboBox	m_symbol_color;
	CListBox	m_plot_list;
	CComboBox	m_line_type;
	CComboBox	m_line_size;
	CComboBox	m_line_color;
	BOOL	m_animate_plots;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPlotOptionsDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CPlotOptionsDialog)
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnApply();
	afx_msg void OnSelectChange();
	afx_msg void OnSelchangeLineColor();
	afx_msg void OnSelchangeSymbolColor();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PLOTOPTIONSDIALOG_H__F29B6051_F432_11D3_A367_00C04F72D141__INCLUDED_)
