//	(c) 2000-2002 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.
#include "stdafx.h"
#include <float.h>
#include "PrestoUtil.h"
#include "Excepts.h"
#include "Equation\Equation.h"
#include "Validate.h"

BOOL StringToFloat(CString &m_text, float &m_value)
{
	// Allow the user to specify a numerical value using an
	// algebraic expression or a text sting in engineering notation
	try{
		SEquation eq(m_text);

		if(eq.GetError())
			// By throwing an Error (as opposed to a string) we signal
			// the test for engineering notation.
			throw Error("Parse Error");

		if(eq.NumVar() != 0)
			throw "No variables allowed in evaluation limits";

		// There is not indepedant variable!
		m_value = eq();

		// The number is outside the range of a float (but within
		// the range of a double, since SEquation was able to compute
		// a value without throwing an error).
		if(!_finite(m_value))
			throw "Can't represent number as float";

		if(eq.GetError())
			throw eq.GetError();
	}
	catch(Error){
		validate string_test;

		// Try to process the string as a constant
		// in engineering notation
		if(!string_test.ValidateString(m_text, validate::isFloat)){
			// We tried everything. It's a bad string
			return FALSE;
		}
		
		// Convert from engineering notation
		m_value = (float)(atof(m_text));

		// Make sure that the number can be represented as a float.
		if(!_finite(m_value))
			return FALSE;

		return TRUE;
	}
	catch(...){
		return FALSE;
	};

	return TRUE;
}