//	(c) 2000-2002 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.

#include "stdafx.h"
#include "sgraph.h"
#include "PropertiesDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropertiesDialog dialog


CPropertiesDialog::CPropertiesDialog(int m_line_thickness_scale, 
									 float m_font_size_scale)
	: CDialog(CPropertiesDialog::IDD, NULL)
{
	line_thickness_scale = m_line_thickness_scale;
	font_size_scale = m_font_size_scale;

	//{{AFX_DATA_INIT(CPropertiesDialog)
	//}}AFX_DATA_INIT
}


void CPropertiesDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropertiesDialog)
	DDX_Control(pDX, IDC_FONT_SIZE_COMBO, m_font_size);
	DDX_Control(pDX, IDC_LINE_THICKNESS_COMBO, m_line_thickness);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPropertiesDialog, CDialog)
	//{{AFX_MSG_MAP(CPropertiesDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropertiesDialog message handlers
BOOL CPropertiesDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_line_thickness.SetCurSel(line_thickness_scale - 1);

	m_font_size.SetCurSel((int)((font_size_scale - 1.0f)*4.0f));

	return TRUE;
}

void CPropertiesDialog::OnOK() 
{
	line_thickness_scale = m_line_thickness.GetCurSel() + 1;
	
	font_size_scale = 1.0f + m_font_size.GetCurSel()*0.25f;
	CDialog::OnOK();
}
