//	(c) 2000 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.

#include "stdafx.h"
#include "sgraph.h"
#include "ScaleDialog.h"
#include "PrestoUtil.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScaleDialog dialog


CScaleDialog::CScaleDialog(float x_max, float x_min, float y_max, float y_min,
						   CWnd* pParent /*=NULL*/)
	: CDialog(CScaleDialog::IDD, pParent)
{
	isDefault = FALSE;
	//{{AFX_DATA_INIT(CScaleDialog)
	m_x_max = _T("");
	m_x_min = _T("");
	m_y_max = _T("");
	m_y_min = _T("");
	//}}AFX_DATA_INIT

	m_x_max.Format("%.4g", x_max);
	m_x_min.Format("%.4g", x_min);
	m_y_max.Format("%.4g", y_max);
	m_y_min.Format("%.4g", y_min);

	applyTo = APPLY_TO_ALL_AXES_CUR_GRAPH;
}


void CScaleDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScaleDialog)
	DDX_Control(pDX, IDC_APPLY_COMBO, m_apply_to);
	DDX_Text(pDX, IDC_SCALE_X_MAX, m_x_max);
	DDX_Text(pDX, IDC_SCALE_X_MIN, m_x_min);
	DDX_Text(pDX, IDC_SCALE_Y_MAX, m_y_max);
	DDX_Text(pDX, IDC_SCALE_Y_MIN, m_y_min);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScaleDialog, CDialog)
	//{{AFX_MSG_MAP(CScaleDialog)
	ON_BN_CLICKED(ID_SCALE_DEFAULT, OnScaleDefault)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScaleDialog message handlers

BOOL CScaleDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the apply to combo box
	m_apply_to.SetCurSel(applyTo);

	UpdateData(FALSE);

	return TRUE;
}

void CScaleDialog::OnScaleDefault() 
{
	isDefault = TRUE;

	applyTo = m_apply_to.GetCurSel();

	CDialog::OnOK();
}

void CScaleDialog::OnOK() 
{
	UpdateData(TRUE);

	applyTo = m_apply_to.GetCurSel();
	
	// Validate and convert all entries
	if(StringToFloat(m_x_max, value_x_max) == FALSE){
		AfxMessageBox("Invalid maximum X value");
		return;
	}

	if(StringToFloat(m_x_min, value_x_min) == FALSE){
		AfxMessageBox("Invalid minimum X value");
		return;
	}

	if(StringToFloat(m_y_max, value_y_max) == FALSE){
		AfxMessageBox("Invalid maximum Y value");
		return;
	}

	if(StringToFloat(m_y_min, value_y_min) == FALSE){
		AfxMessageBox("Invalid minimum Y value");
		return;
	}

	CDialog::OnOK();
}
