//	(c) 2000 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.
#ifndef __SELECT_RECT_H
#define __SELECT_RECT_H

// The 2*space around an object (in pixels) that is attributed to the
// object for the purpose of selection. Must be an even integer.
#define		SELECT_BORDER	10

#define		PI			3.14159265359
#define		TWOPI		(2.0*PI)

// An selection rectangle that can be rotated
class CSelectRect{
private:
	// Angle in radians [0, 2*PI]
	double angle;

	// The center of the rectangle
	int x, y;
	
	// The length/2 and height/2 of the rectangle
	// (in its own reference frame)
	CSize rect_size;

public:
	CSelectRect();
	CSelectRect(CSelectRect &copy);

	void Angle(double m_angle)
	{
		angle = m_angle;
	};

	void Size(const CSize &m_size)
	{
		rect_size.cx = (m_size.cx + SELECT_BORDER)/2;
		rect_size.cy = (m_size.cy + SELECT_BORDER)/2;
	};

	void SizeX(int m_x)
	{
		rect_size.cx = (m_x + SELECT_BORDER)/2;
	};

	void SizeY(int m_y)
	{
		rect_size.cy = (m_y + SELECT_BORDER)/2;
	};

	void X(int m_x)
	{
		x = m_x;
	};
	
	void Y(int m_y)
	{
		y = m_y;
	};

	// Is the point xy within the rectangle?
	BOOL Intersect(CPoint &xy);

	// Draw a dotted selection rectangle
	void Draw(CDC *pDC);
};

#endif // __SELECT_RECT_H