//	(c) 2000 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.

#include "stdafx.h"
#include "sgraph.h"
#include "SetGraphDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetGraphDialog dialog


CSetGraphDialog::CSetGraphDialog(int xAxis, int yAxis, 
								 CWnd* pParent /*=NULL*/)
	: CDialog(CSetGraphDialog::IDD, pParent)
{
	m_xAxis = xAxis;
	m_yAxis = yAxis;

	//{{AFX_DATA_INIT(CSetGraphDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSetGraphDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetGraphDialog)
	DDX_Control(pDX, IDC_SET_GRAPH_COMBO, m_set_graph);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetGraphDialog, CDialog)
	//{{AFX_MSG_MAP(CSetGraphDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetGraphDialog message handlers
BOOL CSetGraphDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	if((m_xAxis == SCALE_LINEAR) && (m_yAxis == SCALE_LINEAR)){
		m_set_graph.SetCurSel(0 /* Linear X, Linear Y*/);
		return TRUE;
	}

	if((m_xAxis == SCALE_LINEAR) && (m_yAxis == SCALE_LOG)){
		m_set_graph.SetCurSel(1 /* Linear X, Log Y*/);
		return TRUE;
	}

	if((m_xAxis == SCALE_LOG) && (m_yAxis == SCALE_LINEAR)){
		m_set_graph.SetCurSel(2 /* Log X, Linear Y*/);
		return TRUE;
	}

	m_set_graph.SetCurSel(3 /* Log X, Log Y*/);
	return TRUE;
}

int CSetGraphDialog::GetXAxisType()
{
	return m_xAxis;
}

int CSetGraphDialog::GetYAxisType()
{
	return m_yAxis;
}

void CSetGraphDialog::OnOK() 
{
	if(m_set_graph.GetCurSel() < 2)
		m_xAxis = SCALE_LINEAR;
	else
		m_xAxis = SCALE_LOG;
	
	if((m_set_graph.GetCurSel() == 0) || (m_set_graph.GetCurSel() == 2))
		m_yAxis = SCALE_LINEAR;
	else
		m_yAxis = SCALE_LOG;

	CDialog::OnOK();
}
