//	(c) 2000-2002 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.
#ifndef __ARRAY
#define __ARRAY

#include "Excepts.h"

#ifndef _DEBUG
#define ARRAY_NO_BOUND
#endif

template <class A>
class array{
	private:
		A *top;
		int len;
	public:
		array()
		{
			top = NULL;
			len = 0;
		};

		array(int n)
		{
			top = new A [n];
			len = n;
		};
	
		array(const array<A> &copy)
		{
			top = NULL;

			(*this) = copy;
		};
		
		~array()
		{
			if(top != NULL){
				delete [] top;
				top = NULL;
			}
		};

		A& operator[](int i)
		{
			#ifndef ARRAY_NO_BOUND
			if((i < 0) || (i >= len))
				throw Error("Index out of bounds in array!");
			#endif // ARRAY_NO_BOUND

			return top[i];
		};

		A* Pointer()
		{
			return top;
		};

		array<A>& operator=(const array<A> &copy)
		{
			if(top){
				delete [] top;
			}

			top = new A [copy.len];
			len = copy.len;

			for(int i = 0;i < len;i++)
				top[i] = copy.top[i];
		}

		int Length() const 
		{
			return len;
		};
};

#endif // __ARRAY