//	(c) 2000 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.
#ifndef __COLOR_H
#define __COLOR_H

// Define a 32 bit value to indicate no color
// (i.e. clear, transparent, etc.).
#define		NO_COLOR		0xff000000

// Enumerate all of the color for index to 32 bit COLORREF
// lookups. Note that the custom color type is handled in a rather
// unusual way. The value, S_CLR_CUSTOM, is just a place holder - not
// a valid color it self (i.e. just a way to indicate that a custom color
// must be set by another method).
enum {S_CLR_BLACK = 0, S_CLR_WHITE, S_CLR_RED, S_CLR_GREEN, S_CLR_BLUE,
	  S_CLR_CYAN, S_CLR_GREY, S_CLR_NONE, S_CLR_CUSTOM};

int ColorToIndex(COLORREF color);
COLORREF IndexToColor(int color);

#endif //__COLOR_H
