#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "Equation.h"

void TestSimplify(char *input);
void TestSimplifyTwo(char *input);
void TestDeriv(char *input, char *dx);

void main()
{
#ifdef OLD_SCHOOL
	TestSimplify("x + 0");
	TestSimplify("0 + x");
	TestSimplify("x * 0");
	TestSimplify("0 * x");
	TestSimplify("0 - x");
	TestSimplify("x - 0");
	TestSimplify("0 / x");
	TestSimplify("0 ^ x");
	TestSimplify("x ^ 0");
	TestSimplify("x ^ 0 + 0");
	TestSimplify("x ^ 0 + 1*0");
	TestSimplify("x ^ 0 + 1*0 + x*sin(0)");
	TestSimplify("x ^ 0 + x*sin(0)");

	TestSimplify("2 + x/2*x -3");
	TestSimplify("2 + x/2*x");
	TestSimplify("2 + x*x*x");

	TestSimplify("x^1 * 1^x + 1^1 + x^0 - x*1");

	//TestSimplify("x + 2.232^2/3*7-3/43*45-2.32-0.3*(12.2/3^1.1*(2*3))");
	//TestSimplify("x + 2.232^2/3*7-3/43*45");
	//TestSimplify("x + 2.232^2/3*7-3/43");
	//TestSimplify("x + 2.232^2/3*7-3");
	//TestSimplify("x + 2.232^2/3*7");
	//TestSimplify("x + 2.034223*10^2");

	//TestDeriv("m*x + b", "x");
	//TestDeriv("exp(a*x)", "x");
	//TestDeriv("((a) + x)/b", "x");
	//TestDeriv("x+++x", "x");
	//TestDeriv("--+-+---+++x", "x");
	TestDeriv("--+-+---+++x", "x");

	
	TestSimplify("x+++x");
	TestSimplify("x * - x");
	TestSimplify("x / - x");
	TestSimplify("-x * - x");
	TestSimplify("-x / - x");
	TestSimplify("-x /  x");
	TestSimplify("log(x)");
	TestSimplify("log(exp(x))");
	TestSimplify("sin(1*asin(x) + 1 -2 + 1)");

	TestSimplify("(1 + x)/(1 + x)");
	TestSimplify("(-1 + x)/-(1 - x)");
	TestSimplify("(-1 + x)/(1 - x)");
	TestSimplify("(-1 + x)/(-(1 - x))");

	#endif // OLD_SCHOOL

	//TestSimplify("(sin(x)^2 - 1)*(sin(x)^2 - 1)/(sin(x)^2 - 1)");
	//TestSimplify("x*10*x + 2*x*x*5");
	//TestSimplify("x + 10*2 - x*1 + 3/x + 4");

	//TestSimplify("w + 2*x*xold/y^2*(y/(2*x)-2*Tanh(y/(4*x)))");

	//TestSimplify("2*x*xold/y^2*(2/3*(y/(4*x))^3)");
	//TestSimplify("10*exp(-(x-1)^2/3) + 5*exp(-(x-2)^2/5)");
	//TestDeriv("10*exp(-(x-a)^2/4)","a");

	//TestSimplify("2*x^2");
	//TestDeriv("exp(-a*(x/s)^2)*b*x/s", "a");
	//TestDeriv("exp(-a*(x/s)^2)*b*x/s", "b");
	//TestDeriv("exp(-a*(x/s)^2)*b*x/s", "s");

	//TestSimplify("exp(-(x/s)^2)");
	
	//TestDeriv("exp(-(x/s)^2)", "s");
	//TestDeriv("exp(-a*(x/s)^2)*b*x/s", "s");

	//TestSimplify("(a*x)^2*x^(-2)");

	TestSimplifyTwo("x + y");
	TestSimplifyTwo("x - y");
}

void TestDeriv(char *input, char *dx)
{
	int i;

	printf("*****************DERIVATIVE***********************\n");
	printf("Input string: y = %s\n", input);

	SEquation my_eq(input);

	if(my_eq.GetError()){
		printf("Error: %s\n", my_eq.GetError());
	}

	if(my_eq.DefineIndepVar("x")){
		printf("Indep var defined!\n");
	}
	else{
		printf("Couldn't define indep var\n");
		my_eq.ClearError();
	}

	// Print out the variables
	for(i = 0;i < my_eq.NumVar();i++){
		printf("var[%d] = '%s'\n", i, my_eq.GetVarName(i));
	}

	if(my_eq.IsValid(FALSE)){
		printf("Eq is valid!\n");

		printf("Before Deriv:\n");
		my_eq(stdout);

		SEquation deriv;

		deriv = my_eq.Deriv(dx);

		if(deriv.IsValid(FALSE)){
			printf("Deriv is valid!\n");

			deriv(stdout);

			printf("About to simplify deriv\n");

			deriv.Simplify();

			if(deriv.IsValid(FALSE)){
				printf("After simplify\n");

				deriv(stdout);

				// Set any parameter values to friendly constants
				for(i = 0;i < deriv.NumVar();i++){
					if(!deriv.IsIndepVar(i)){
						deriv.SetVar(i, (float)(2.0));
					}
				}

				if(deriv.IsValid(TRUE)){
					printf("Equation is good to go!\n");
					//for(float foo = -100.0;foo < 100.0;foo += 0.5)
					//	printf("%f\t%f\n", foo, deriv(foo));

					printf("deriv(%f) = %f\n", 0.001f, deriv(0.001f));
					printf("deriv(%f) = %f\n", 0.0f, deriv(0.0f));
					printf("deriv(%f) = %f\n", -0.001f, deriv(-0.001f));
				}
				else{
					printf("Equation NOT ready for evaluation!\n");
				}

			}
			else{
				printf("Unable to simplify derivative\n");

				printf("Deriv Error: %s\n", deriv.GetError());
			}
		}
		else{
			printf("Deriv is NOT valid!\n");

			printf("Deriv Error: %s\n", deriv.GetError());
		}

	}
	else{
		printf("Eq is NOT valid!\n");
	}

	printf("**************************************************\n");
}

void TestSimplify(char *input)
{
	int i;

	printf("*******************SIMPLIFY******************\n");
	printf("Input string: y = %s\n", input);

	SEquation my_eq(input);

	if(my_eq.GetError()){
		printf("Error: %s\n", my_eq.GetError());
	}

	if(my_eq.DefineIndepVar("x")){
		printf("Indep var defined!\n");
	}
	else{
		printf("Couldn't define indep var\n");
		my_eq.ClearError();
	}

	// Print out the variables
	for(i = 0;i < my_eq.NumVar();i++){
		printf("var[%d] = '%s'\n", i, my_eq.GetVarName(i));
	}

	// Set any parameter values to friendly constants
	for(i = 0;i < my_eq.NumVar();i++){
		if(!my_eq.IsIndepVar(i)){
			my_eq.SetVar(i, (float)(2.0));
		}
	}

	if(my_eq.IsValid()){
		printf("Eq is valid!\n");

		printf("Before Simplify:\n");
		my_eq(stdout);
		//printf("y(0) = %f\n", my_eq(0.0f));
		my_eq.Simplify();

		if(my_eq.GetError()){
			printf("Simplify Error: %s\n", my_eq.GetError());
		}

		printf("After Simplify:\n");
		my_eq(stdout);

		printf("y(-1) = %f\n", my_eq(-1.0f));
		printf("y(0) = %f\n", my_eq(0.0f));
		printf("y(1) = %f\n", my_eq(1.0f));
	}
	else{
		printf("Eq is NOT valid!\n");
	}

	printf("**************************************************\n");
}


void TestSimplifyTwo(char *input)
{
	int i;

	printf("*******************SIMPLIFY******************\n");
	printf("Input string: f(x,y) = %s\n", input);

	SEquation my_eq(input);

	if(my_eq.GetError()){
		printf("Error: %s\n", my_eq.GetError());
	}

	if(my_eq.DefineIndepVar("x", "y")){
		printf("Indep var defined!\n");
	}
	else{
		printf("Couldn't define indep var\n");
		my_eq.ClearError();
	}

	// Print out the variables
	for(i = 0;i < my_eq.NumVar();i++){
		printf("var[%d] = '%s'\n", i, my_eq.GetVarName(i));
	}

	// Set any parameter values to friendly constants
	for(i = 0;i < my_eq.NumVar();i++){
		if(!my_eq.IsIndepVar(i)){
			my_eq.SetVar(i, (float)(2.0));
		}
	}

	if(my_eq.IsValid()){
		printf("Eq is valid!\n");

		printf("Before Simplify:\n");
		my_eq(stdout);
		//printf("y(0) = %f\n", my_eq(0.0f));
		my_eq.Simplify();

		if(my_eq.GetError()){
			printf("Simplify Error: %s\n", my_eq.GetError());
		}

		printf("After Simplify:\n");
		my_eq(stdout);

		printf("f(-1, -2) = %f\n", my_eq(-1.0f, -2.0f));
		printf("f(-1, 2) = %f\n", my_eq(-1.0f, 2.0f));
		printf("f(1, -2) = %f\n", my_eq(1.0f, -2.0f));
		printf("f(1, 2) = %f\n", my_eq(1.0f, 2.0f));
	}
	else{
		printf("Eq is NOT valid!\n");
	}

	printf("**************************************************\n");
}


