// This header, when turned on via the MEMORY_DEBUG flag,
// tracks and reports memory leaks and other assorted memory
// errors for C++ programs. By default, the output is dumped to
// stderr (cerr) but also will be written to a log file if the 
// MEMORY_DEBUG_LOG is defined to a valid file name.

#ifdef MEMORY_DEBUG

#ifndef __MEMORY
#define __MEMORY

void *operator new (size_t nb, char *filename, int line);
void *operator new (size_t nb);
void operator delete (void * ptr, char *filename, int line);
void operator delete (void * ptr);

// MYDEBUG_NEW is simply a placeholder to massage existing
// "new" operators into "new(__FILE__, __LINE__)" operators.
#define MYDEBUG_NEW   new(__FILE__, __LINE__)
#define	new MYDEBUG_NEW

// I don't think the following code is allowed!
// That is, the delete operator doesn't take a initializer
// argument list like the new operator.
//#define MYDEBUG_DELETE   delete (__FILE__, __LINE__)
//#define	delete MYDEBUG_DELETE

#endif // __MEMORY 

#endif // MEMORY_DEBUG