//	(c) 2000-2002 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.
#include "stdafx.h"
#include "sobject.h"
#include "presto.h"

#include <math.h>

/////////////////////////////////////////////////////////////////////////////
//	*** Helper functions ***
/////////////////////////////////////////////////////////////////////////////
void SerializeFont(LOGFONT &font, CArchive& ar)
{
	if(ar.IsStoring()){
		ar << font.lfHeight;
		ar << font.lfWidth;
		ar << font.lfEscapement;
		ar << font.lfOrientation;
		ar << font.lfWeight;
		ar << font.lfItalic;
		ar << font.lfUnderline;
		ar << font.lfStrikeOut;
		ar << font.lfCharSet;
		ar << font.lfOutPrecision;
		ar << font.lfClipPrecision;
		ar << font.lfQuality;
		ar << font.lfPitchAndFamily;
		ar.Write(font.lfFaceName, LF_FACESIZE);
	}
	else{
		ar >> font.lfHeight;
		ar >> font.lfWidth;
		ar >> font.lfEscapement;
		ar >> font.lfOrientation;
		ar >> font.lfWeight;
		ar >> font.lfItalic;
		ar >> font.lfUnderline;
		ar >> font.lfStrikeOut;
		ar >> font.lfCharSet;
		ar >> font.lfOutPrecision;
		ar >> font.lfClipPrecision;
		ar >> font.lfQuality;
		ar >> font.lfPitchAndFamily;
		ar.Read(font.lfFaceName, LF_FACESIZE);
	}
}

/////////////////////////////////////////////////////////////////////////////
//	*** SObject ***
/////////////////////////////////////////////////////////////////////////////

int SObject::lineScale = 1;
float SObject::fontScale = 1;

void SObject::Serialize(CArchive& ar)
{
	if(ar.IsStoring()){
		// Always write the current version
		ar << SGRAPH_VERSION;
		ar << isDrawn;
		//ar << isSelected; <-- Don't store the "isSelected" variable
		ar << x;
		ar << y;
	}
	else{
		ar >> version;
		ar >> isDrawn;
		//ar >> isSelected;  <-- Don't store the "isSelected" variable
		ar >> x;
		ar >> y;
	}
}

void SObject::PreparePrinting(CDC* pDC, long scaleMul, long scaleDiv, CRect &extent)
{
	isPrinting = TRUE;

	printScaleMul = scaleMul;
	printScaleDiv = scaleDiv;
}

void SObject::CleanUpPrinting(CDC* pDC, CRect &extent)
{
	isPrinting = FALSE;

	printScaleMul = 1;
	printScaleDiv = 1;
}

BOOL SObject::Select(CPoint &xy, CDC* pDC, CRect &extent)
{
	// The object must be drawn to be selected
	if(!isDrawn)
		return FALSE;
	
	// Is the point xy within the selection rectangle?
	isSelected = SelectRect(pDC, extent).Intersect(xy);

	return isSelected;
}