//	(c) 2000 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.

#ifndef __VALIDATE
#define __VALIDATE

// Validate text strings as numbers

class validate{
private:
	// The current state
	BOOL readDecimal;
	BOOL readMinus;
	BOOL readPlus;
	BOOL readE;

	BOOL isnumber(char c)
	{
		if(isdigit(c))
			return TRUE;

		if(c == '.'){
			if(readDecimal)
				return FALSE;

			readDecimal = TRUE;
			return TRUE;
		}

		if(c == '-'){
			if(readMinus)
				return FALSE;

			readMinus = TRUE;
			return TRUE;
		}

		if(c == '+'){
			if(readPlus)
				return FALSE;

			readPlus = TRUE;

			return TRUE;
		}

		if(c == 'E'){
			if(readE)
				return FALSE;

			readE = TRUE;
			readMinus = FALSE;
			readPlus = FALSE;

			return TRUE;
		}

		if(c == 'e'){
			if(readE)
				return FALSE;

			readE = TRUE;
			readMinus = FALSE;
			readPlus = FALSE;

			return TRUE;
		}

		return FALSE;
	};

	void Init(int mask)
	{
		readDecimal = FALSE;
		readMinus = FALSE;
		readE = FALSE;
		readPlus = FALSE;

		if(mask & isInt){
			readDecimal = TRUE;
			// Allow large integers (i.e. 1e4 = 10000)
			//readE = TRUE;
		}
	};

public:
	// Options that control the behaviour of the 
	// ValidateString function
	enum {isInt = 1,
		  isFloat = 2,
		  isPositive = 4,
		  isNegative = 8};

	BOOL ValidateString(CString &str, int mask = 0)
	{	
		Init(mask);

		// Remove leading and trailing white space
		str.TrimLeft();
		str.TrimRight();

		// Check for empty strings
		if(str.GetLength() == 0)
			return FALSE;

		for(int i = 0;i < str.GetLength();i++)
			if(!isnumber(str[i]))
				return FALSE;
		
		// Enforce the proper sign
		if((mask & isNegative) && (str[0] != '-'))
			return FALSE;
		
		if((mask & isPositive) && (str[0] == '-'))
			return FALSE;

		return TRUE;
	}
};

#endif // __VALIDATE